library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SELF_RST is
    Port ( CLK  : in  std_logic;
           RST  : in  std_logic;
           ENB  : in  std_logic;
           DATA : in  std_logic_vector( 7 downto 0 );
			  L    : out std_logic_vector( 1 downto 0 ) );
end SELF_RST;

architecture RTL of SELF_RST is

signal STATE : std_logic_vector( 1 downto 0 );
  
constant S0 : std_logic_vector := "00";
constant S1 : std_logic_vector := "01";
constant S2 : std_logic_vector := "10";
constant S3 : std_logic_vector := "11";

begin

process( CLK, RST ) begin
	if ( RST ='1') then
		L <= "00";
		STATE <= S0;
	elsif( CLK'event and CLK='1') then
		case STATE is
			when S0 =>
				L <= "00";
				if( ENB='1' and DATA=X"2A") then
					STATE <= S1;
				end if;
			when S1 =>
				L <= "01";
				STATE <= S2;
			when S2 =>
				L <= "10";
				STATE <= S3;
			when S3 =>
				L <= "11";
				STATE <= S0;
			when others => STATE <= S0;
		end case;
	end if;
end process;

end RTL;
